import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/* global Response */
import * as authorization from 'auth-header';
import RelyingParty from '@solid/oidc-rp';
import PoPToken from '@solid/oidc-rp/lib/PoPToken';
import { currentUrl, navigateTo, toUrlString } from './url-util';
import { defaultStorage, getData, updateStorage } from './storage';
export function login(_x, _x2) {
  return _login.apply(this, arguments);
}

function _login() {
  _login = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(idp, options) {
    var rp;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return getRegisteredRp(idp, options);

          case 3:
            rp = _context.sent;
            _context.next = 6;
            return saveAppHashFragment(options.storage);

          case 6:
            return _context.abrupt("return", sendAuthRequest(rp, options));

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](0);
            console.warn('Error logging in with WebID-OIDC');
            console.error(_context.t0);
            return _context.abrupt("return", null);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 9]]);
  }));
  return _login.apply(this, arguments);
}

export function currentSession() {
  return _currentSession.apply(this, arguments);
}

function _currentSession() {
  _currentSession = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee2() {
    var storage,
        rp,
        url,
        storeData,
        session,
        _args2 = arguments;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            storage = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : defaultStorage();
            _context2.prev = 1;
            _context2.next = 4;
            return getStoredRp(storage);

          case 4:
            rp = _context2.sent;

            if (rp) {
              _context2.next = 7;
              break;
            }

            return _context2.abrupt("return", null);

          case 7:
            // Obtain and clear the OIDC URL fragment
            url = currentUrl();

            if (/#(.*&)?access_token=/.test(url)) {
              _context2.next = 10;
              break;
            }

            return _context2.abrupt("return", null);

          case 10:
            window.location.hash = '';
            _context2.next = 13;
            return restoreAppHashFragment(storage);

          case 13:
            _context2.next = 15;
            return getData(storage);

          case 15:
            storeData = _context2.sent;
            _context2.next = 18;
            return rp.validateResponse(url, storeData);

          case 18:
            session = _context2.sent;

            if (session) {
              _context2.next = 21;
              break;
            }

            return _context2.abrupt("return", null);

          case 21:
            return _context2.abrupt("return", _objectSpread({}, session, {
              webId: session.idClaims.sub,
              idp: session.issuer
            }));

          case 24:
            _context2.prev = 24;
            _context2.t0 = _context2["catch"](1);
            console.warn('Error finding a WebID-OIDC session');
            console.error(_context2.t0);
            return _context2.abrupt("return", null);

          case 29:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[1, 24]]);
  }));
  return _currentSession.apply(this, arguments);
}

export function logout(_x3, _x4) {
  return _logout.apply(this, arguments);
}

function _logout() {
  _logout = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee3(storage, fetch) {
    var rp;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getStoredRp(storage);

          case 2:
            rp = _context3.sent;

            if (!rp) {
              _context3.next = 20;
              break;
            }

            _context3.prev = 4;
            _context3.next = 7;
            return rp.logout();

          case 7:
            _context3.prev = 7;
            _context3.next = 10;
            return fetch('/.well-known/solid/logout', {
              credentials: 'include'
            });

          case 10:
            _context3.next = 14;
            break;

          case 12:
            _context3.prev = 12;
            _context3.t0 = _context3["catch"](7);

          case 14:
            _context3.next = 20;
            break;

          case 16:
            _context3.prev = 16;
            _context3.t1 = _context3["catch"](4);
            console.warn('Error logging out of the WebID-OIDC session');
            console.error(_context3.t1);

          case 20:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[4, 16], [7, 12]]);
  }));
  return _logout.apply(this, arguments);
}

export function getRegisteredRp(_x5, _x6) {
  return _getRegisteredRp.apply(this, arguments);
}

function _getRegisteredRp() {
  _getRegisteredRp = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee4(idp, options) {
    var rp;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return getStoredRp(options.storage);

          case 2:
            rp = _context4.sent;

            if (!(!rp || rp.provider.url !== idp || !rp.registration.redirect_uris.includes(options.callbackUri))) {
              _context4.next = 9;
              break;
            }

            _context4.next = 6;
            return registerRp(idp, options);

          case 6:
            rp = _context4.sent;
            _context4.next = 9;
            return storeRp(options.storage, idp, rp);

          case 9:
            return _context4.abrupt("return", rp);

          case 10:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getRegisteredRp.apply(this, arguments);
}

function getStoredRp(_x7) {
  return _getStoredRp.apply(this, arguments);
}

function _getStoredRp() {
  _getStoredRp = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee5(storage) {
    var data, rpConfig;
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return getData(storage);

          case 2:
            data = _context5.sent;
            rpConfig = data.rpConfig;

            if (!rpConfig) {
              _context5.next = 9;
              break;
            }

            rpConfig.store = storage;
            return _context5.abrupt("return", RelyingParty.from(rpConfig));

          case 9:
            return _context5.abrupt("return", null);

          case 10:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getStoredRp.apply(this, arguments);
}

function storeRp(_x8, _x9, _x10) {
  return _storeRp.apply(this, arguments);
}

function _storeRp() {
  _storeRp = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee6(storage, idp, rp) {
    return _regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return updateStorage(storage, function (data) {
              return _objectSpread({}, data, {
                rpConfig: rp
              });
            });

          case 2:
            return _context6.abrupt("return", rp);

          case 3:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _storeRp.apply(this, arguments);
}

function registerRp(idp, opts) {
  var storage = opts.storage,
      callbackUri = opts.callbackUri;
  var responseType = 'id_token token';
  var clientNameI18n = {};
  Object.entries(opts).filter(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        _ = _ref2[1];

    return key.startsWith('clientName#');
  }).forEach(function (_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        key = _ref4[0],
        value = _ref4[1];

    return clientNameI18n[key.replace('clientName#', 'client_name#')] = value;
  });
  var supplementaryOptions = {
    logo_uri: opts.logoUri,
    contacts: opts.contacts,
    client_name: opts.clientName
  };

  var registration = _objectSpread({
    issuer: idp,
    grant_types: ['implicit'],
    redirect_uris: [callbackUri],
    response_types: [responseType],
    scope: 'openid profile'
  }, clientNameI18n, {}, supplementaryOptions);

  var options = {
    defaults: {
      authenticate: {
        redirect_uri: callbackUri,
        response_type: responseType
      }
    },
    store: storage
  };
  return RelyingParty.register(idp, registration, options);
}

function sendAuthRequest(_x11, _x12) {
  return _sendAuthRequest.apply(this, arguments);
}

function _sendAuthRequest() {
  _sendAuthRequest = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee7(rp, _ref5) {
    var callbackUri, storage, data, url;
    return _regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            callbackUri = _ref5.callbackUri, storage = _ref5.storage;
            _context7.next = 3;
            return getData(storage);

          case 3:
            data = _context7.sent;
            _context7.next = 6;
            return rp.createRequest({
              redirect_uri: callbackUri
            }, data);

          case 6:
            url = _context7.sent;
            _context7.next = 9;
            return updateStorage(storage, function () {
              return data;
            });

          case 9:
            return _context7.abrupt("return", navigateTo(url));

          case 10:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));
  return _sendAuthRequest.apply(this, arguments);
}

function saveAppHashFragment(_x13) {
  return _saveAppHashFragment.apply(this, arguments);
}

function _saveAppHashFragment() {
  _saveAppHashFragment = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee8(store) {
    return _regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.next = 2;
            return updateStorage(store, function (data) {
              return _objectSpread({}, data, {
                appHashFragment: window.location.hash
              });
            });

          case 2:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));
  return _saveAppHashFragment.apply(this, arguments);
}

function restoreAppHashFragment(_x14) {
  return _restoreAppHashFragment.apply(this, arguments);
}
/**
 * Answers whether a HTTP response requires WebID-OIDC authentication.
 */


function _restoreAppHashFragment() {
  _restoreAppHashFragment = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee9(store) {
    return _regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            _context9.next = 2;
            return updateStorage(store, function (_ref6) {
              var _ref6$appHashFragment = _ref6.appHashFragment,
                  appHashFragment = _ref6$appHashFragment === void 0 ? '' : _ref6$appHashFragment,
                  data = _objectWithoutProperties(_ref6, ["appHashFragment"]);

              window.location.hash = appHashFragment;
              return data;
            });

          case 2:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9);
  }));
  return _restoreAppHashFragment.apply(this, arguments);
}

export function requiresAuth(resp) {
  if (resp.status !== 401) {
    return false;
  }

  var wwwAuthHeader = resp.headers.get('www-authenticate');

  if (!wwwAuthHeader) {
    return false;
  }

  var auth = authorization.parse(wwwAuthHeader);
  return auth.scheme === 'Bearer' && auth.params && auth.params.scope === 'openid webid';
}
/**
 * Fetches a resource, providing the WebID-OIDC ID Token as authentication.
 * Assumes that the resource has requested those tokens in a previous response.
 */

export function fetchWithCredentials(_x15, _x16, _x17, _x18) {
  return _fetchWithCredentials.apply(this, arguments);
}

function _fetchWithCredentials() {
  _fetchWithCredentials = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee10(session, fetch, input, options) {
    var headers, origHeaders, entries, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, name, value, popToken;

    return _regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            // Create a copy of the headers
            headers = {};
            origHeaders = options ? options.headers : input.headers;

            if (!origHeaders) {
              _context10.next = 23;
              break;
            }

            entries = typeof origHeaders.entries === 'function' ? origHeaders.entries() : Object.entries(origHeaders);
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context10.prev = 7;

            for (_iterator = entries[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              _step$value = _slicedToArray(_step.value, 2), name = _step$value[0], value = _step$value[1];
              headers[name] = value;
            }

            _context10.next = 15;
            break;

          case 11:
            _context10.prev = 11;
            _context10.t0 = _context10["catch"](7);
            _didIteratorError = true;
            _iteratorError = _context10.t0;

          case 15:
            _context10.prev = 15;
            _context10.prev = 16;

            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }

          case 18:
            _context10.prev = 18;

            if (!_didIteratorError) {
              _context10.next = 21;
              break;
            }

            throw _iteratorError;

          case 21:
            return _context10.finish(18);

          case 22:
            return _context10.finish(15);

          case 23:
            _context10.next = 25;
            return PoPToken.issueFor(toUrlString(input), session);

          case 25:
            popToken = _context10.sent;
            headers.authorization = "Bearer ".concat(popToken);
            return _context10.abrupt("return", fetch(input, _objectSpread({}, options, {
              credentials: 'include',
              headers: headers
            })));

          case 28:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10, null, [[7, 11, 15, 23], [16,, 18, 22]]);
  }));
  return _fetchWithCredentials.apply(this, arguments);
}